#include <qglobal.h>
#include <qstring.h>
#include <qdebug.h>
#include <functional>

#include <iostream>
#include <qvariant.h>
#include <qmap.h>

class Base {
	public:
		void Command (QString cmd, QVariant arg) {
			if (this->procs.contains (cmd)) {
				this->procs[cmd] (this, arg);
			};
		};
	protected:
		typedef std::function<void (Base*, QVariant)> ComProc;
		QMap<QString, ComProc> procs;
};

class Derived : public Base {
	public:
		Derived () {
			this->procs["do-derived"] = &Derived::cmdDoDerivedThing;
		};
	private:
		void cmdDoDerivedThing (QVariant arg) {
			qDebug () << "hello!";
		};
};

int main(int argc, char *argv[])
{
	Base *ptr = new Derived ();
	ptr->Command ("do-derived", QVariant());
	return 0;
}
